# urls.py
from django.urls import path
from .views import AppliedApprenticeshipListView, AppliedByMeCastingCallAPI, AppliedGigWorkListView, AppliedInternshipListView, AppliedUserListView, ApplyForApprenticeshipView, ApplyForInternshipView,  ApprenticeshipDetailView, ApprenticeshipListAPI, AwardByProjectID, CastingCallApplicantsAPI, CastingCallDetailAPIView, CastingCallListAPI, CollabAPIView,  CreateApprenticeshipView, CreateInternshipView, CreatedByMeCastingCallAPI, CreatedGigWorkListView, CreditViewSet, EditApprenticeshipView, EditInternshipView, GigWorkFormView, GigWorkListAPI, HeadshotUploadView, InternshipAppliedUserListView, InternshipDetailView, InternshipListAPI, InternshipRejectedUserListView, InternshipSaveLaterUserListView, InternshipSelectedUserListView, InternshipWaitingListUserListView, MyApprenticeshipListView, MyInternshipListView, OpportunitiesGlobalListView, ProjectCreditsAPIView, ProjectListAPI, ProjectMediaListView, ProjectMediaUploadView, ProjectPhotoListView, RejectedUserListView, RemoveHeadshotView, SaveLaterUserListView,SaveProjectView,FollowProjectView,ProjectPhotoUploadView,RemoveCreditAPIView,CastingCallApplicationView, SearchBarView, SelectedUserListView, ShareApprenticeshipView, ShareCastingCallView, ShareGigWorkView, ShareInternshipView, ShareProjectView, SoftDeleteCastingCallView, UpdateApprenticeshipApplicationStatusView, UpdateApprenticeshipStatusView, UpdateCastingCallStatusView, UpdateGigworkApplicationStatusView, UpdateGigworkStatusView, UpdateInternshipApplicationStatusView, UpdateInternshipStatusView, UserDetailsView, UserProjectDetails, UserProjectsView, WaitingListUserListView
from .views import CastingCallFormView, ProjectFormView,ProjectTitleListView,GigWorkSearchView
from .views import EventRegistrationCreateView,CastingCallSearchView,GlobalSearchView,ProjectCastingCallListView,ProjectDetailView
from .views import ProjectFeedbackListView,ProjectTeamMembersView,EditProjectView,CastingCrewView,UpdateProjectView,ProjectCommentsView,ReportProjectView,CastingCallFormEditView
from .views import AppliedUsersView,ChangeProfileStatusView,ProjectDeleteView,ProjectCommentDeleteView,AddTeamMemberView,RemoveTeamMemberView,EditTeamMemberRoleView,RemoveTeamView,AddTeamView,FeedbackDeleteView
from .views import AwardAPIView,AddGigWorkAPIView,GetGigWorkAPIView,EditGigWorkAPIView,ApplyGigWorkAPIView,ListAppliedUsersAPIView,DeleteGigWorkAPIView,ListGigWorkAPIView,SuggestUserAPIView, SearchView, GetSortlist
credit_view = CreditViewSet.as_view({
    'post': 'add_credit',
    'delete': 'remove_credit'
})

manage_credit_view = CreditViewSet.as_view({
    'post': 'manage_credit_request'
})

exit_credit_view = CreditViewSet.as_view({
    'delete': 'exit_credit'
})

credit_request_view = CreditViewSet.as_view({'post': 'request_credit'})

urlpatterns = [

    path('global-search/', GlobalSearchView.as_view(), name='global_search'),

    
    path('gigworks/add', AddGigWorkAPIView.as_view(), name='add_gigwork'),
    path('gigworks/list/', ListGigWorkAPIView.as_view(), name='list-gigwork'),
    path('gigworks/details/<int:gigwork_id>/', GetGigWorkAPIView.as_view(), name="get_gigwork_details"),
    path('gigworks/edit/<int:gigworks_id>/', EditGigWorkAPIView.as_view(), name="edit_gigwork"),
    path('gigworks/<int:gigworks_id>/delete/', DeleteGigWorkAPIView.as_view(), name='delete-gigwork'),
    path('gigworks/apply-gigwork', ApplyGigWorkAPIView.as_view(), name="apply-gigwork"),
    path('gigworks/<int:gigwork_id>/applicants/', ListAppliedUsersAPIView.as_view(), name='list-applied-users'),
    path('gigwork/<int:gigwork_id>/status/', UpdateGigworkStatusView.as_view(), name='update-gigwork-status'),
    path('gigwork/form/<int:user_id>/', GigWorkFormView.as_view(), name='gigwork_form_detail'),  # GET, PUT, DELETE
    path('gigwork/search/', GigWorkSearchView.as_view(), name='gigwork-search'),
    path('gigwork/updatestatus/<int:gigwork_id>/', UpdateGigworkApplicationStatusView.as_view(), name='update-gigwork-application-status'),
    path('applied-gigworks/', AppliedGigWorkListView.as_view(), name='applied-gigworks'),
    path('created-gigworks/', CreatedGigWorkListView.as_view(), name='created-gigworks'),

    path('castingcall/form/', CastingCallFormView.as_view(), name='castingcall_form'),
    path('castingcall/form/<int:project_id>/', CastingCallFormView.as_view(), name='castingcall_form_detail'),
    path('castingcall/edit/form/<int:casting_id>/', CastingCallFormEditView.as_view(), name='castingcall_edit'),
    path('casting-call/search/', CastingCallSearchView.as_view(), name='casting_call_search'),
    path('casting-call/<int:castingcall_id>/status/', UpdateCastingCallStatusView.as_view(), name='update-castingcall-status'),
    path('casting-call/list/', CastingCallListAPI.as_view(), name='casting-call-list'),
    path('casting-call/delete/<int:casting_call_id>/', SoftDeleteCastingCallView.as_view(), name='casting-call-delete'),
    path('casting-calls/applied-by-me/', AppliedByMeCastingCallAPI.as_view(), name='applied-by-me-casting-calls'),
    path('casting-calls/created-by-me/', CreatedByMeCastingCallAPI.as_view(), name='created-by-me-casting-calls'),

    path('project/form/', ProjectFormView.as_view(), name='project_form'),
    path('project/form/<int:user_id>/', ProjectFormView.as_view(), name='project_form_detail'),
    path('project/<int:project_id>/', ProjectDetailView.as_view(), name='project-detail'),
    path('project/<int:project_id>/update/', UpdateProjectView.as_view(), name='update_project'),
    path('project/<int:project_id>/delete/', ProjectDeleteView.as_view(), name='project-delete'),
    path('project/<int:project_id>/casting-calls/', ProjectCastingCallListView.as_view(), name='project-casting-calls'),
    path('project/<int:project_id>/feedbacks/', ProjectFeedbackListView.as_view(), name='project-feedbacks'),
    path('project/<int:project_id>/feedback/<int:feedback_id>/', FeedbackDeleteView.as_view(), name='feedback-delete'),
    path('awards/', AwardAPIView.as_view(), name='awards-list-create'),
    path('awards/<int:pk>/', AwardAPIView.as_view(), name='awards-detail'),
    path('awards_by_project/<int:project_id>/', AwardByProjectID.as_view(), name='awards-detail'),
    

    path('project/<int:project_id>/edit/', EditProjectView.as_view(), name='edit-project'),
    path('project/list/', ProjectListAPI.as_view(), name='project-list'),
    path('project/<int:project_id>/comments/', ProjectCommentsView.as_view(), name='project-comments'),
    path('project/<int:project_id>/comment/<int:comment_id>/',ProjectCommentDeleteView.as_view(),name='project_comment-delte'),
    path('project/<int:projectId>/report/', ReportProjectView.as_view(), name='report-project'),
    path('project/<int:projectId>/save/', SaveProjectView.as_view(), name='save-project'),
    path('project/<int:projectId>/follow/', FollowProjectView.as_view(), name='follow-project'),
    path('project/<int:projectId>/pressrelease/photos/', ProjectPhotoUploadView.as_view(), name='upload-project-photo'),
    path('project/<int:projectId>/pressrelease/photoslist/', ProjectPhotoListView.as_view(), name='project-press-releases-list'),
    path('project/<int:projectId>/mediarelease/upload/', ProjectMediaUploadView.as_view(), name='upload-project-video'),
    path('project/<int:projectId>/mediarelease/uploadslist/', ProjectMediaListView.as_view(), name='upload-project-video'),
    path('project/<int:projectId>/team/<int:userId>/remove-credit/', RemoveCreditAPIView.as_view(), name='remove-credit'),

    path('event/form/', EventRegistrationCreateView.as_view(), name='event-registration'),
    path('event/form/<int:user_id>/', EventRegistrationCreateView.as_view(), name='event_registration_detail'),  
    
    path('project/title/<int:user_id>/', ProjectTitleListView.as_view(), name='title_list'), 


    path('project/<int:project_id>/team-members/', ProjectTeamMembersView.as_view(), name='project-team-members'),
    path('teams/<int:team_id>/members/add/', AddTeamMemberView.as_view(), name='add-team-member'),
    path('teams/<int:team_id>/members/<int:member_id>/remove/', RemoveTeamMemberView.as_view(), name='remove-team-member'),
    path('teams/<int:team_id>/members/<int:member_id>/edit-role/', EditTeamMemberRoleView.as_view(), name='edit-team-member-role'),
    path('teams/<int:team_id>/remove/', RemoveTeamView.as_view(), name='remove-team'),
    path('projects/<int:project_id>/add-team/', AddTeamView.as_view(), name='add-team'),

  # path('project/<int:project_id>/casting-crew/', ProjectCastingCrewView.as_view(), name='project-casting-crew'),
    path('casting-crew/<int:project_id>/', CastingCrewView.as_view(), name='casting-crew-detail'),
    path('casting-calls/<int:casting_call_id>/apply/', CastingCallApplicationView.as_view(), name='apply-casting-call'),
    path('casting-call/<int:casting_call_id>/applied-users/', AppliedUsersView.as_view(), name='applied_users'),
    path('casting-call/changestatus', ChangeProfileStatusView.as_view(), name='change-profile-status'),
    path('castingcall/<int:casting_call_id>/users/<str:status_filter>/', CastingCallApplicantsAPI.as_view(), name='castingcall-applicants'),

    path('suggest_user', SuggestUserAPIView.as_view(), name='suggest_user'),
    path('collab_user', CollabAPIView.as_view(), name='collab_user'),
    path('opportunities/globallist/', OpportunitiesGlobalListView.as_view(), name='opportunity-global-list'),
    path('search/globallist/', SearchBarView.as_view(), name='opportunity-global-list'),
    path('search/sort-by-sortname', SearchView.as_view(), name='sort-by-sortname'),
    path('get/sortlist/', GetSortlist.as_view(), name='sort-list'),
    

    path('add-headshot/', HeadshotUploadView.as_view(), name='upload-headshot'),
    path('remove-headshot/', RemoveHeadshotView.as_view(), name='remove-headshot'),

    path('apprenticeship/create/', CreateApprenticeshipView.as_view(), name='create_apprenticeship'),
    path('apprenticeship/<int:apprenticeship_id>/', ApprenticeshipDetailView.as_view(), name='apprenticeship-detail'),
    path('apprenticeship/<int:apprenticeship_id>/edit', EditApprenticeshipView.as_view(), name='edit-detail'),
    path('apprenticeship/created_by_me/', MyApprenticeshipListView.as_view(), name='apprenticeship-creted-by-me'),
    path('apprenticeship/applied_list/', AppliedApprenticeshipListView.as_view(), name='applied-apprenticeship-list'),
    path('apprenticeship/<int:apprenticeship_id>/status/', UpdateApprenticeshipStatusView.as_view(), name='update-apprenticeship-status'),
    path('apprenticeship/updatestatus/<int:apprenticeship_id>/', UpdateApprenticeshipApplicationStatusView.as_view(), name='update-apprenticeshiapapplication-status'),
    path('apprenticeship/apply/', ApplyForApprenticeshipView.as_view(), name='apply-for-apprenticeship'),
    path('apprenticeship/<int:apprenticeship_id>/applied_users/', AppliedUserListView.as_view(), name='applied-users'),
    path('apprenticeship/<int:apprenticeship_id>/selected_users/', SelectedUserListView.as_view(), name='selected-users'),
    path('apprenticeship/<int:apprenticeship_id>/waiting_list_users/', WaitingListUserListView.as_view(), name='waiting-list-users'),
    path('apprenticeship/<int:apprenticeship_id>/save_later_users/', SaveLaterUserListView.as_view(), name='save-later-users'),
    path('apprenticeship/<int:apprenticeship_id>/rejected_users/', RejectedUserListView.as_view(), name='rejected-users'),


    path('internship/create/', CreateInternshipView.as_view(), name='create_internship'),
    path('internship/<int:internship_id>/', InternshipDetailView.as_view(), name='internship-detail'),
    path('internship/<int:internship_id>/edit', EditInternshipView.as_view(), name='edit-detail'),
    path('internship/created_by_me/', MyInternshipListView.as_view(), name='internship-creted-by-me'),
    path('internship/applied_list/', AppliedInternshipListView.as_view(), name='applied-internship-list'),
    path('internship/<int:internship_id>/status/', UpdateInternshipStatusView.as_view(), name='update-internship-status'),
    path('internship/updatestatus/<int:internship_id>/', UpdateInternshipApplicationStatusView.as_view(), name='update-internship-application-status'),
    path('internship/apply/', ApplyForInternshipView.as_view(), name='apply-for-internship'),
    path('internship/<int:internship_id>/applied_users/', InternshipAppliedUserListView.as_view(), name='internship-applied-users'),
    path('internship/<int:internship_id>/selected_users/', InternshipSelectedUserListView.as_view(), name='internship-selected-users'),
    path('internship/<int:internship_id>/waiting_list_users/', InternshipWaitingListUserListView.as_view(), name='internship-waiting-list-users'),
    path('internship/<int:internship_id>/save_later_users/', InternshipSaveLaterUserListView.as_view(), name='internship-save-later-users'),
    path('internship/<int:internship_id>/rejected_users/', InternshipRejectedUserListView.as_view(), name='internship-rejected-users'),

    path('user-details/<int:application_id>/<str:type_of_application>/', UserDetailsView.as_view(), name='user-details'),
    path('projects/artography/<int:user_id>/', UserProjectDetails.as_view(), name='user_projects'),
    path('credits/add/', credit_view, name='add_credit'),
    path('credits/<int:credit_id>/remove/', credit_view, name='remove_credit'),
    path('credits/<int:credit_id>/manage/', manage_credit_view, name='manage_credit_request'),
    path('credits/<int:credit_id>/exit/', exit_credit_view, name='exit_credit'),
    path('credits/request/', credit_request_view, name='request_credit'),
    path('credits/<int:user_id>/projects/', UserProjectsView.as_view(), name='user-projects'),
    path('credits/<int:project_id>/credits/', ProjectCreditsAPIView.as_view(), name='project-credits'),

    path('casting-call/<int:casting_call_id>/', CastingCallDetailAPIView.as_view(), name='casting_call_detail'),

    path('internship/list/', InternshipListAPI.as_view(), name='internship-list'),
    path('apprenticeship/list/', ApprenticeshipListAPI.as_view(), name='apprenticeship-list'),
    path('gig-work/list/', GigWorkListAPI.as_view(), name='gig-work-list'),

    ##########################   Share opportunities ##############################
    path('gigwork/share/', ShareGigWorkView.as_view(), name='gigwork-share'),
    path('castingcall/share/', ShareCastingCallView.as_view(), name='castingcall-share'),
    path('internship/share/', ShareInternshipView.as_view(), name='internship-share'),
    path('apprenticeship/share/', ShareApprenticeshipView.as_view(), name='apprenticeship-share'),
    path('project/share/', ShareProjectView.as_view(), name='project-share'),
]